{% extends "base.html" %}
{% block title %}Home{% endblock %}
{% block heading %}{% endblock %}
{% block pageid %}home{% endblock %}
{% block jscript %}
    <style>
        .question {
            font-family: Helvetica, sans-serif;
            /*font-variant: small-caps; */
            font-style: bold;
            font-size: 18px;
            padding-bottom: 5px;
        }

        .answer {
            margin-left: 30px;
            margin-right: 30px;
            font-size: 14px;
            background-color: #e2ebf2;
            padding-top: 1px;
            padding-bottom: 1px;
            padding-left: 20px;
            padding-right: 20px;
        }
    </style>
{% endblock %}

{% block content %}

<!-- stuff for the recent events plot -->

<style>
body {
  font: 10px sans-serif;
}

.axis text {
  font: 16px sans-serif;
  /*font-weight: bold; */
}

.axis line {
  fill: none;
  stroke: #000;
  shape-rendering: crispEdges;
}

.axis path {
  display: none;
}

.legend {
    font-size: 16px;
    font-weight: bold;
    text-anchor: start;
    cursor: pointer;
}

</style>

{% if recent_events != "" %}
<h2>Recent Events</h2>
<div id="recent_events_plot"></div>
<br/>
{% endif %}

<!-- I find myself needing some more space. -->
<!-- <br/>  -->

<h2>
{% if title %}
    {{ title }}
{% else %}
    GraceDB Overview
{% endif %}
</h2>

<div class="text">

{# Can customize main informational display on home page or just use default #}
{% if information %}
    {{ information|safe }}
{% else %}
    <p>
    The gravitational-wave candidate event database (GraceDB) is a service operated by the <a href="https://www.ligo.org/">LIGO Scientific Collaboration</a>. It provides a centralized location for aggregating and retrieving information about candidate gravitational-wave events. GraceDB provides an <a href="{% url "legacy_apiweb:default:root" %}">API</a> for programmatic access, and a <a href="https://ligo-gracedb.readthedocs.io/">client package</a> is available for interacting with the API.
    </p>
    <h3>Useful information</h3>
    <ul>
    <li><b style="color: red;">*NEW*</b> O3 public alert <a href="{% url "superevents:public-alerts-O3" %}">summary page</a>.</li>
    <li>Information about GW alerts and real-time data products is available in the <a href="https://emfollow.docs.ligo.org/userguide/">LIGO/Virgo Public Alert Guide</a>.</li>
    <li>Found a bug? LIGO/Virgo users can report issues on the GraceDB <a href="https://git.ligo.org/lscsoft/gracedb/issues">Gitlab page</a>.</li>
    </ul>
{% endif %}
    <p><b>Server code version: <a href="https://git.ligo.org/lscsoft/gracedb/tree/gracedb-{{server_version}}">{{server_version}}</a></b></p>
</div>

<!--XXX Infrastructure for human signoffs. Hopefully this will not be permanent. -->
{% if signoff_authorized %}
    {% if signoff_superevent_ids|length or new_signoff_graceids|length or older_signoff_graceids|length %}
    <div class="signoff-area">
    <h2>Attention {{signoff_instrument}} Operator</h2>
    <br />
    {% if signoff_superevent_ids|length %}
        <h3>The following superevents require your signoff:</h3>
        {% if signoff_superevent_ids|length %}
        <ul>
        {% for s_id in signoff_superevent_ids %}
            <li><a href="{% url "superevents:view" s_id %}">{{ s_id }}</a></li>
        {% endfor %}
        </ul>
        {% endif %}
    {% endif %}
    {% if new_signoff_graceids|length or older_signoff_graceids|length %}
        <h3>The following events require your sign-off:</h3>
        {% if new_signoff_graceids|length %}
        <p>Events submitted within the last 24 hours:</p>
        <ul>
        {% for graceid in new_signoff_graceids %}
            <li><a href="{% url "view" graceid %}">{{ graceid }}</a></li>
        {% endfor %} 
        </ul>
        {% endif %}
        {% if older_signoff_graceids|length %}
        <p>Events older than 24 hours:</p>
        <ul>
        {% for graceid in older_signoff_graceids %}
            <li><a href="{% url "view" graceid %}">{{ graceid }}</a></li>
        {% endfor %}
        </ul>
        {% endif %}
    {% endif %}
    <p>Please click on the link(s) above and use the form at the top of the page.</p>
    </div>
    {% endif %}
{% endif %}

<!-- lots of script for the recent events plot -->
{% if recent_events %}
<script src="https://cdnjs.cloudflare.com/ajax/libs/d3/3.5.5/d3.min.js"></script>
<script>

var margin = {top: 0, right: 100, bottom: 70, left: 200};
var width = 1000 - margin.left - margin.right;
var delta_y = 26;

// Times look like "2015-10-15T13:08:31+00:00
var parseDate = d3.time.format("%Y-%m-%dT%X+00:00").parse;

var x = d3.time.scale()
    .range([0, width]);

var y = d3.scale.ordinal()
//var color = d3.scale.category10();
var color = d3.scale.ordinal();

var xAxis = d3.svg.axis()
    .scale(x)
    .orient("bottom");

var svg = d3.select("#recent_events_plot").append("svg")
    .attr("width", width + margin.left + margin.right)


var data_string = '{{ recent_events|safe }}';

var data = JSON.parse(data_string);

// Convert the text in the created column to dates, use to set the x domain.
data.forEach(function(d) {
    d.created = parseDate(d.created);
});
x.domain(d3.extent(data, function(d) { return d.created; }));

// I suspect there is a better and less annoying way of doing all this.
// But I don't really know what it is. We specify the ordering of the 
// pipelines and the color for each pipeline that may be present.
var PIPELINE_ORDER = [ 'gstlal', 'MBTAOnline', 'CWB', 'oLIB', 'Fermi', 'Swift', 'SNEWS', 'HardwareInjection'];

// These are the first 8 colors of category 10
var COLOR_HASH = {};
COLOR_HASH['gstlal']            = '#1f77b4';
COLOR_HASH['MBTAOnline']        = '#ff7f0e';
COLOR_HASH['CWB']               = '#2ca02c';
COLOR_HASH['oLIB']               = '#d62728';
COLOR_HASH['Fermi']             = '#9467bd';
COLOR_HASH['Swift']             = '#8c564b';
COLOR_HASH['SNEWS']             = '#e377c2';
COLOR_HASH['HardwareInjection'] = '#7f7f7f';

// Pull out the unique pipeline names present in the data
var data_pipelines = d3.map(data, function(d) { return d.pipeline; }).keys(); 

// Select pipelines from our ordering according to those present in the data.
var pipelines = [];
PIPELINE_ORDER.forEach(function(d) {
    if (data_pipelines.indexOf(d) >= 0) {
        pipelines.push(d);
    }
});

// Create the list of colors
var pipeline_colors = [];
pipelines.forEach(function(d) {
    pipeline_colors.push(COLOR_HASH[d]);
});

// Now set the domain and range of our color map.
color.domain(pipelines);
color.range(pipeline_colors);

// Now that you know how many pipelines there are, you can determine the height.
height = pipelines.length * delta_y;

var container = svg
    .attr("height", height + margin.top + margin.bottom)
  .append("g")
    .attr("transform", "translate(" + margin.left + "," + margin.top + ")");

// Calculate the height coordinates for the different pipelines.
var y_range_values = [];
pipelines.forEach(function(d, i) {
    y_range_values.push(height - i*delta_y);
});
y.domain(pipelines).range(y_range_values);

// Create the yAxis here, since you need a valid scale.
var yAxis = d3.svg.axis()
    .scale(y)
    .orient("left");

var xAxis_yloc = height + delta_y/2;
container.append("g")
    .attr("class", "x axis")
    .attr("transform", "translate(0," + xAxis_yloc + ")")
    .call(xAxis)
  .selectAll("text")
    .attr("y", 6)
    .attr("x", -12)
    .attr("dy", "0.5em")
    .attr("transform", "rotate(315)")
    .style("text-anchor", "end");

var yAxis_xloc = - delta_y/2;
container.append("g")
    .attr("class", "y axis")
    .attr("transform", "translate(" + yAxis_xloc + ",0)")
    .call(yAxis)

container.selectAll(".y.axis text")
    .attr("fill", function(d) { return color(d); })

var line_length = 12;

var get_url = function(d) {
    return {% url 'home' %} + d.graceid;
}

container.append("g").selectAll("line")
   .data(data)
.enter().append("svg:a")
  .attr("xlink:href", function(d) { return get_url(d); })
.append("line")
  .attr("x1", function(d) { return x(d.created); })
  .attr("x2", function(d) { return x(d.created); })
  .attr("y1", function(d) { return y(d.pipeline) - line_length/2; })
  .attr("y2", function(d) { return y(d.pipeline) + line_length/2; })
  .attr("stroke-width", 5)
  .attr("stroke", function(d) { return color(d.pipeline); })

</script>
{% endif %}
{% endblock %}
